%%%%%%need check%%%%%%%%

%%%%%%%evaluate ppr on phage%%%%%%%
clear
load('../train100to400/test_data.mat')
ppr=readtable('ppr.csv');
ppr=table2cell(ppr);

TP=0;
TN=0;
FN=0;
FP=0;

targets=zeros(1,size(test_data,1));
outputs=zeros(1,size(test_data,1));
for i=1:1:size(test_data,1)
    [m,n]=max(test_data(i).label);
    if n==1 && strcmp(ppr{i,6},'phage')
        TP=TP+1;
    elseif n~=1 && ~strcmp(ppr{i,6},'phage')
        TN=TN+1;
    elseif n==1 && ~strcmp(ppr{i,6},'phage')
        FN=FN+1;
    elseif n~=1 && strcmp(ppr{i,6},'phage')
        FP=FP+1;
    end
    t=test_data(i).label;
    t=str2num(t(1));
    p=ppr{i,3};
    targets(i)=t;
    outputs(i)=p;
end
TPR=TP/(TP+FN)
FPR=FP/(FP+TN)
[X,Y,TT,AUC]=perfcurve(targets,outputs,1);
AUC
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%evaluate vf%%%%%%%%%%%%
clear
load('../train100to400/test_data.mat')
vf=readtable('vf.csv');
vf=table2cell(vf);

TP=0;
TN=0;
FN=0;
FP=0;

targets=zeros(1,size(test_data,1));
outputs=zeros(1,size(test_data,1));
for i=1:1:size(test_data,1)
    [m,n]=max(test_data(i).label);
    if n==1 && vf{i,4}>=0.5
        TP=TP+1;
    elseif n~=1 && vf{i,4}<0.5
        TN=TN+1;
    elseif n==1 && vf{i,4}<0.5
        FN=FN+1;
    elseif n~=1 && vf{i,4}>=0.5
        FP=FP+1;
    end
    t=test_data(i).label;
    t=str2num(t(1));
    p=vf{i,4};
    targets(i)=t;
    outputs(i)=p;
end
TPR=TP/(TP+FN)
FPR=FP/(FP+TN)
[X,Y,TT,AUC]=perfcurve(targets,outputs,1);
AUC
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%evaluate vs%%%%%%%%%%%%%%%%%
clear
load('../train100to400/test_data.mat');
vs=readtable('vs.csv','Delimiter',',','ReadVariableName',false);
vs=table2cell(vs);
score=1;
for i=1:1:size(vs,1)
    if contains(vs{i,1},'pretty sure')
        score=1;
    elseif contains(vs{i,1},'quite sure')
        score=0.75;
    elseif contains(vs{i,1},'not so sure')
        score=0.5;
    end
    vs{i,13}=score;
end

TP=0;
TN=0;
FN=0;
FP=0;

targets=zeros(1,size(test_data,1));
outputs=zeros(1,size(test_data,1));
parfor i=1:1:size(test_data,1)
    %%%%if predict by vs%%%%%%
    is_predict=0;
    p=0;
    for j=1:1:size(vs,1)
        l=strfind(vs{j,1},'_');
        if size(l,2)<3
            continue
        end
        num=vs{j,1};
        num=num(l(2)+1:l(3)-1);
        num=str2num(num);
        if num==i
            is_predict=1;
            p=vs{j,13};
            break
        end
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%
    [m,n]=max(test_data(i).label);
    if n==1 && is_predict==1
        TP=TP+1;
    elseif n~=1 && is_predict==0
        TN=TN+1;
    elseif n==1 && is_predict==0
        FN=FN+1;
    elseif n~=1 && is_predict==1
        FP=FP+1;
    end
    t=test_data(i).label;
    t=str2num(t(1));
    targets(i)=t;
    outputs(i)=p;
    disp(i)
end
TPR=TP/(TP+FN)
FPR=FP/(FP+TN)
[X,Y,TT,AUC]=perfcurve(targets,outputs,1);
AUC
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%evaluate ppr on plasmid%%%%%%%%
clear
load('../train100to400/test_data.mat')
ppr=readtable('ppr.csv');
ppr=table2cell(ppr);

TP=0;
TN=0;
FN=0;
FP=0;

targets=zeros(1,size(test_data,1));
outputs=zeros(1,size(test_data,1));
for i=1:1:size(test_data,1)
    [m,n]=max(test_data(i).label);
    if n==3 && strcmp(ppr{i,6},'plasmid')
        TP=TP+1;
    elseif n~=3 && ~strcmp(ppr{i,6},'plasmid')
        TN=TN+1;
    elseif n==3 && ~strcmp(ppr{i,6},'plasmid')
        FN=FN+1;
    elseif n~=3 && strcmp(ppr{i,6},'plasmid')
        FP=FP+1;
    end
    t=test_data(i).label;
    t=str2num(t(3));
    p=ppr{i,5};
    targets(i)=t;
    outputs(i)=p;
end
TPR=TP/(TP+FN)
FPR=FP/(FP+TN)
[X,Y,TT,AUC]=perfcurve(targets,outputs,1);
AUC
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%evaluate pf%%%%%%%%%
clear
load('../train100to400/test_data.mat');
pf=readtable('pf.txt');
pf=table2cell(pf);

TP=0;
TN=0;
FN=0;
FP=0;

targets=zeros(1,size(test_data,1));
outputs=zeros(1,size(test_data,1));
for i=1:1:size(test_data,1)
    [m,n]=max(test_data(i).label);
    if n==3 && contains(pf{i,6},'plasmid')
        TP=TP+1;
    elseif n~=3 && ~contains(pf{i,6},'plasmid')
        TN=TN+1;
    elseif n==3 && ~contains(pf{i,6},'plasmid')
        FN=FN+1;
    elseif n~=3 && contains(pf{i,6},'plasmid')
        FP=FP+1;
    end
    t=test_data(i).label;
    t=str2num(t(3));
    p=pf{i,25}+pf{i,26}+pf{i,27}+pf{i,28}+pf{i,29}+pf{i,30}+pf{i,31}+pf{i,32}+pf{i,33}+pf{i,34};
    targets(i)=t;
    outputs(i)=p;
end
TPR=TP/(TP+FN)
FPR=FP/(FP+TN)
[X,Y,TT,AUC]=perfcurve(targets,outputs,1);
AUC
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%evaluate cBar%%%%%%%%%%%%%%
clear
load('../train100to400/test_data.mat')
cBar=readtable('cBar.txt');
cBar=table2cell(cBar);
TP=0;
TN=0;
FN=0;
FP=0;

targets=zeros(1,size(test_data,1));
outputs=zeros(1,size(test_data,1));
for i=1:1:size(test_data,1)
    [m,n]=max(test_data(i).label);
    if n==3 && strcmp(cBar{i,3},'Plasmid')
        TP=TP+1;
    elseif n~=3 && ~strcmp(cBar{i,3},'Plasmid')
        TN=TN+1;
    elseif n==3 && ~strcmp(cBar{i,3},'Plasmid')
        FN=FN+1;
    elseif n~=3 && strcmp(cBar{i,3},'Plasmid')
        FP=FP+1;
    end
    t=test_data(i).label;
    t=str2num(t(3));
    targets(i)=t;
    if strcmp(cBar{i,3},'Plasmid')
        outputs(i)=1;
    else
        outputs(i)=0;
    end
end
TPR=TP/(TP+FN)
FPR=FP/(FP+TN)
[X,Y,TT,AUC]=perfcurve(targets,outputs,1);
AUC
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
